#include "stdafx.h"

#include "kryString.h"
#include "kryArray.h"

template <class T, class RT>
kryArray<T,RT>::kryArray() : m_count(0), m_capacity(10)
{
  this->m_array = new T[m_capacity];
}

template <class T, class RT>
kryArray<T,RT>::kryArray(int capacity) : m_count(0), m_capacity(capacity)
{
  this->m_array = new T[m_capacity];
}

template <class T, class RT>
kryArray<T,RT>::~kryArray()
{
  delete [] this->m_array;
}

template <class T, class RT>
void kryArray<T,RT>::Resize(int new_size)
{
  T *new_array = new T[new_size];
  for(int i = 0; i < this->m_count; i++)
    new_array[i] = this->m_array[i];

  delete [] this->m_array;
  this->m_array = new_array;
}

template <class T, class RT>
void kryArray<T,RT>::Add(T obj)
{
  if(this->m_capacity == this->m_count)
    this->Resize(this->m_capacity * 2);

  this->m_array[this->m_count] = obj;
  this->m_count++;
}

template <class T, class RT>
int kryArray<T,RT>::GetCount()
{
  return this->m_count;
}

template <class T, class RT>
RT kryArray<T,RT>::operator [](int index)
{
  return this->m_array[index];
}


template class kryArray<kryString>;
template class kryArray<int>;

