class kryColor : public kryObject
{
public:
  kryColor();
  kryColor(int id, char *t_id, char *name, int red, int green, int blue);
  
  void Set(int id, char *t_id, char *name, int red, int green, int blue);

  void *GetUserData();
  void SetUserData(void *data);

  int GetRed();
  int GetGreen();
  int GetBlue();

  void SetColor(int red, int green, int blue);
  void Reset();

  char *GetName();
  int GetID();
  char *GetTextID();

  void DisableOpacity();
  void EnableOpacity();
  gboolean HasOpacity();
  int GetAlpha();
  void SetAlpha(int alpha);

  gboolean IsInitialized();

  enum
  {
    SIGNAL_CHANGED,
    SIGNAL_COUNT
  };

private:
  int m_id;
  char *m_text_id;
  char *m_name;

  /* Color intensity information */
  int m_red;
  int m_green;
  int m_blue;
  int m_alpha;

  /* Original color intensity information. 
     Used for resetting the color to the original value. */
  int m_orig_red;
  int m_orig_green;
  int m_orig_blue;
  int m_orig_alpha;

  gboolean m_initialized;
  void *m_user_data;
  gboolean m_opacity;
};


