//#include "kryIterator.h"

template <class T,class V>
class kryHash
{
public:
  kryHash(GHashFunc hash_func, GEqualFunc key_equal_func);
  kryHash(GHashFunc hash_func, GEqualFunc key_equal_func, GDestroyNotify key_destroy_func, GDestroyNotify value_destroy_func);
  ~kryHash();

  void GetKeysIterator(kryListIterator<T> *iter);

  V Lookup(T key);
  void Remove(T key);
  void Replace(T key, V value);
  void Insert(T key, V value);
  int GetKeyCount();
private:
  kryList<T> m_keys;
  GHashTable *m_hash;
  GEqualFunc m_equalFunc;
};


