//#include "kryIterator.h"

template <class T>
class kryListIterator;

template <class T>
struct kryListNode
{
  struct kryListNode<T> *prev;
  struct kryListNode<T> *next;
  T data;
};

template <class T>
class kryList
{
public:

  kryList();
  kryList(kryList<T> & list);
  ~kryList();
  kryListNode<T> * Append(T data);
  kryListNode<T> * Add(T data) { return Append(data); }
  //kryListNode *nth(int index);
  T GetNthData(int index);
  int GetLength();
  int GetCount();
  void ForEach(GFunc func, void *userdata);
  void Insert(T data, int position);
  struct kryListNode<T> *Find(T data, GEqualFunc func = NULL, int *index = NULL);
  int IndexOf(T data, GEqualFunc func = NULL);
  void Remove(T data, GEqualFunc func = NULL);
  void Clear();
  void operator =(kryList & list);
  T operator[] (int index);

  kryListNode<T> *m_head;
  kryListNode<T> *m_tail;

  void GetIterator(kryListIterator<T> *iter);
  void GetNthIterator(kryListIterator<T> *iter, int index);

  void AddIterator(kryListIterator<T> *iter);
  void RemoveIterator(kryListIterator<T> *iter);

  void PrintDebug();

  friend class kryListIterator<T>;
  //friend kryListIterator<T>;
private:
  void Remove(kryListNode<T> *node);

  int m_length;
  int m_id;

  GList *m_iterators;
};


