class kryPrefManager
{
public:
  kryPrefManager();
  ~kryPrefManager();

  void Clear();

  gboolean Load();
  gboolean Load(char *filename);
  gboolean Save();
  gboolean Save(char *filename);

  // getting values
  int GetInt(char *section_name, char *key, int def_value);
  int GetInt(char *key, int def_value);

  char *GetString(char *section_name, char *key);
  char *GetString(char *key);

  GList *GetList(char *section_name, char *key);
  GList *GetList(char *key);

  // setting values
  void SetInt(char *section, char *key, int val);
  void SetInt(char *key, int val);
  
  void SetString(char *section, char *key, char *val);
  void SetString(char *key, char *val);
  
  void SetListAddString(char *section, char *key, char *val);
  void SetListAddString(char *key, char *val);

  void SetListAddInt(char *section, char *key, int val);
  void SetListAddInt(char *key, int val);

  void Remove(char *section_name, char *key);
  void Remove(char *key);

  void SetFilename(char *filename);

  void PushSection(char *section);
  char *GetSection();
  void PopSection();
  void SetSection(char *section);

private:

  kryPrefSection *AddSection(char *section_name);

  kryHash<char *, kryPrefSection *> *m_sections;

  char *m_filename;

  GList *m_section_stack;
  char *m_section_current;
};


